diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/spectrum/model/matrix-based-channel-model.h ns-3.44/src/spectrum/model/matrix-based-channel-model.h
--- ns-3.43/src/spectrum/model/matrix-based-channel-model.h	2024-10-09 16:41:10.088656700 -0700
+++ ns-3.44/src/spectrum/model/matrix-based-channel-model.h	2025-03-09 16:55:49.695372300 -0700
@@ -11,11 +11,11 @@
 #define MATRIX_BASED_CHANNEL_H
 
 // #include <complex>
-#include <ns3/matrix-array.h>
-#include <ns3/nstime.h>
-#include <ns3/object.h>
-#include <ns3/phased-array-model.h>
-#include <ns3/vector.h>
+#include "ns3/matrix-array.h"
+#include "ns3/nstime.h"
+#include "ns3/object.h"
+#include "ns3/phased-array-model.h"
+#include "ns3/vector.h"
 
 #include <tuple>
 
@@ -25,7 +25,7 @@
 class MobilityModel;
 
 /**
- * \ingroup spectrum
+ * @ingroup spectrum
  *
  * This is an interface for a channel model that can be described
  * by a channel matrix, e.g., the 3GPP Spatial Channel Models,
@@ -84,9 +84,9 @@
         /**
          * Returns true if the ChannelMatrix object was generated
          * considering node b as transmitter and node a as receiver.
-         * \param aAntennaId the ID of the antenna array of the a node
-         * \param bAntennaId the ID of the antenna array of the b node
-         * \return true if b is the rx and a is the tx, false otherwise
+         * @param aAntennaId the ID of the antenna array of the a node
+         * @param bAntennaId the ID of the antenna array of the b node
+         * @return true if b is the rx and a is the tx, false otherwise
          */
         bool IsReverse(uint32_t aAntennaId, uint32_t bAntennaId) const
         {
@@ -178,11 +178,11 @@
      * matrix corresponds to H_ab, a call to IsReverse (idA, idB) will return
      * false, conversely, IsReverse (idB, idA) will return true.
      *
-     * \param aMob mobility model of the a device
-     * \param bMob mobility model of the b device
-     * \param aAntenna antenna of the a device
-     * \param bAntenna antenna of the b device
-     * \return the channel matrix
+     * @param aMob mobility model of the a device
+     * @param bMob mobility model of the b device
+     * @param aAntenna antenna of the a device
+     * @param bAntenna antenna of the b device
+     * @return the channel matrix
      */
     virtual Ptr<const ChannelMatrix> GetChannel(Ptr<const MobilityModel> aMob,
                                                 Ptr<const MobilityModel> bMob,
@@ -193,9 +193,9 @@
      * Returns a channel parameters structure used to obtain the channel between
      * the nodes with mobility objects passed as input parameters.
      *
-     * \param aMob mobility model of the a device
-     * \param bMob mobility model of the b device
-     * \return the channel matrix
+     * @param aMob mobility model of the a device
+     * @param bMob mobility model of the b device
+     * @return the channel matrix
      */
     virtual Ptr<const ChannelParams> GetParams(Ptr<const MobilityModel> aMob,
                                                Ptr<const MobilityModel> bMob) const = 0;
@@ -203,9 +203,9 @@
     /**
      * Generate a unique value for the pair of unsigned integer of 32 bits,
      * where the order does not matter, i.e., the same value will be returned for (a,b) and (b,a).
-     * \param a the first value
-     * \param b the second value
-     * \return return an integer representing a unique value for the pair of values
+     * @param a the first value
+     * @param b the second value
+     * @return return an integer representing a unique value for the pair of values
      */
     static uint64_t GetKey(uint32_t a, uint32_t b)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/spectrum/model/microwave-oven-spectrum-value-helper.cc ns-3.44/src/spectrum/model/microwave-oven-spectrum-value-helper.cc
--- ns-3.43/src/spectrum/model/microwave-oven-spectrum-value-helper.cc	2024-10-09 16:41:10.088656700 -0700
+++ ns-3.44/src/spectrum/model/microwave-oven-spectrum-value-helper.cc	2025-03-09 16:55:49.695372300 -0700
@@ -21,7 +21,7 @@
 static Ptr<SpectrumModel> g_MicrowaveOvenSpectrumModel6Mhz;
 
 /**
- * \ingroup spectrum
+ * @ingroup spectrum
  * Init a static class containing the MWO #2 model (5Mhz)
  */
 static class MicrowaveOvenSpectrumModel5MhzInitializer
@@ -45,7 +45,7 @@
 } g_MicrowaveOvenSpectrumModel5MhzInitializerInstance; //!< MWO model #2
 
 /**
- * \ingroup spectrum
+ * @ingroup spectrum
  * Init a static class containing the MWO #1 model (6Mhz)
  */
 static class MicrowaveOvenSpectrumModel6MhzInitializer
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/spectrum/model/microwave-oven-spectrum-value-helper.h ns-3.44/src/spectrum/model/microwave-oven-spectrum-value-helper.h
--- ns-3.43/src/spectrum/model/microwave-oven-spectrum-value-helper.h	2024-10-09 16:41:10.088656700 -0700
+++ ns-3.44/src/spectrum/model/microwave-oven-spectrum-value-helper.h	2025-03-09 16:55:49.695372300 -0700
@@ -15,7 +15,7 @@
 {
 
 /**
- * \ingroup spectrum
+ * @ingroup spectrum
  *
  * This class provides methods for the creation of SpectrumValue
  * instances that mimic the Power Spectral Density of commercial
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/spectrum/model/multi-model-spectrum-channel.cc ns-3.44/src/spectrum/model/multi-model-spectrum-channel.cc
--- ns-3.43/src/spectrum/model/multi-model-spectrum-channel.cc	2024-10-09 16:41:10.088656700 -0700
+++ ns-3.44/src/spectrum/model/multi-model-spectrum-channel.cc	2025-03-09 16:55:49.695372300 -0700
@@ -13,19 +13,19 @@
 #include "spectrum-propagation-loss-model.h"
 #include "spectrum-transmit-filter.h"
 
-#include <ns3/angles.h>
-#include <ns3/antenna-model.h>
-#include <ns3/double.h>
-#include <ns3/log.h>
-#include <ns3/mobility-model.h>
-#include <ns3/net-device.h>
-#include <ns3/node.h>
-#include <ns3/object.h>
-#include <ns3/packet-burst.h>
-#include <ns3/packet.h>
-#include <ns3/propagation-delay-model.h>
-#include <ns3/propagation-loss-model.h>
-#include <ns3/simulator.h>
+#include "ns3/angles.h"
+#include "ns3/antenna-model.h"
+#include "ns3/double.h"
+#include "ns3/log.h"
+#include "ns3/mobility-model.h"
+#include "ns3/net-device.h"
+#include "ns3/node.h"
+#include "ns3/object.h"
+#include "ns3/packet-burst.h"
+#include "ns3/packet.h"
+#include "ns3/propagation-delay-model.h"
+#include "ns3/propagation-loss-model.h"
+#include "ns3/simulator.h"
 
 #include <algorithm>
 #include <iostream>
@@ -39,10 +39,10 @@
 NS_OBJECT_ENSURE_REGISTERED(MultiModelSpectrumChannel);
 
 /**
- * \brief Output stream operator
- * \param lhs output stream
- * \param rhs the TxSpectrumModelInfoMap to print
- * \return an output stream
+ * @brief Output stream operator
+ * @param lhs output stream
+ * @param rhs the TxSpectrumModelInfoMap to print
+ * @return an output stream
  */
 std::ostream&
 operator<<(std::ostream& lhs, TxSpectrumModelInfoMap_t& rhs)
@@ -132,7 +132,7 @@
                   "phy->GetRxSpectrumModel () returned 0. Please check that the RxSpectrumModel is "
                   "already set for the phy before calling MultiModelSpectrumChannel::AddRx (phy)");
 
-    SpectrumModelUid_t rxSpectrumModelUid = rxSpectrumModel->GetUid();
+    const auto rxSpectrumModelUid = rxSpectrumModel->GetUid();
 
     RemoveRx(phy);
 
@@ -152,8 +152,8 @@
              txInfoIterator != m_txSpectrumModelInfoMap.end();
              ++txInfoIterator)
         {
-            Ptr<const SpectrumModel> txSpectrumModel = txInfoIterator->second.m_txSpectrumModel;
-            SpectrumModelUid_t txSpectrumModelUid = txSpectrumModel->GetUid();
+            auto txSpectrumModel = txInfoIterator->second.m_txSpectrumModel;
+            const auto txSpectrumModelUid = txSpectrumModel->GetUid();
 
             if (rxSpectrumModelUid != txSpectrumModelUid &&
                 !txSpectrumModel->IsOrthogonal(*rxSpectrumModel))
@@ -174,7 +174,7 @@
     Ptr<const SpectrumModel> txSpectrumModel)
 {
     NS_LOG_FUNCTION(this << txSpectrumModel);
-    SpectrumModelUid_t txSpectrumModelUid = txSpectrumModel->GetUid();
+    const auto txSpectrumModelUid = txSpectrumModel->GetUid();
     auto txInfoIterator = m_txSpectrumModelInfoMap.find(txSpectrumModelUid);
 
     if (txInfoIterator == m_txSpectrumModelInfoMap.end())
@@ -191,14 +191,15 @@
              rxInfoIterator != m_rxSpectrumModelInfoMap.end();
              ++rxInfoIterator)
         {
-            Ptr<const SpectrumModel> rxSpectrumModel = rxInfoIterator->second.m_rxSpectrumModel;
-            SpectrumModelUid_t rxSpectrumModelUid = rxSpectrumModel->GetUid();
+            auto rxSpectrumModel = rxInfoIterator->second.m_rxSpectrumModel;
+            const auto rxSpectrumModelUid = rxSpectrumModel->GetUid();
 
             if (rxSpectrumModelUid != txSpectrumModelUid &&
                 !txSpectrumModel->IsOrthogonal(*rxSpectrumModel))
             {
                 NS_LOG_LOGIC("Creating converter between SpectrumModelUid "
                              << txSpectrumModelUid << " and " << rxSpectrumModelUid);
+
                 SpectrumConverter converter(txSpectrumModel, rxSpectrumModel);
                 auto ret2 = txInfoIterator->second.m_spectrumConverterMap.insert(
                     std::make_pair(rxSpectrumModelUid, converter));
@@ -220,22 +221,66 @@
 
     NS_ASSERT(txParams->txPhy);
     NS_ASSERT(txParams->psd);
-    Ptr<SpectrumSignalParameters> txParamsTrace =
-        txParams->Copy(); // copy it since traced value cannot be const (because of potential
-                          // underlying DynamicCasts)
+    auto txParamsTrace = txParams->Copy(); // copy it since traced value cannot be const (because of
+                                           // potential underlying DynamicCasts)
     m_txSigParamsTrace(txParamsTrace);
 
     auto txMobility = txParams->txPhy->GetMobility();
-    auto txSpectrumModelUid = txParams->psd->GetSpectrumModelUid();
+    const auto txSpectrumModelUid = txParams->psd->GetSpectrumModelUid();
     NS_LOG_LOGIC("txSpectrumModelUid " << txSpectrumModelUid);
 
+    const auto txInfoIterator =
+        FindAndEventuallyAddTxSpectrumModel(txParams->psd->GetSpectrumModel());
+    NS_ASSERT(txInfoIterator != m_txSpectrumModelInfoMap.cend());
+
+    NS_LOG_LOGIC("converter map for TX SpectrumModel with Uid " << txInfoIterator->first);
+    NS_LOG_LOGIC("converter map size: " << txInfoIterator->second.m_spectrumConverterMap.size());
+    NS_LOG_LOGIC("converter map first element: "
+                 << txInfoIterator->second.m_spectrumConverterMap.begin()->first);
+
+    std::map<SpectrumModelUid_t, Ptr<SpectrumValue>> convertedPsds{};
     for (auto rxInfoIterator = m_rxSpectrumModelInfoMap.begin();
          rxInfoIterator != m_rxSpectrumModelInfoMap.end();
          ++rxInfoIterator)
     {
-        SpectrumModelUid_t rxSpectrumModelUid = rxInfoIterator->second.m_rxSpectrumModel->GetUid();
+        const auto rxSpectrumModelUid = rxInfoIterator->second.m_rxSpectrumModel->GetUid();
         NS_LOG_LOGIC("rxSpectrumModelUids " << rxSpectrumModelUid);
 
+        Ptr<SpectrumValue> convertedTxPowerSpectrum;
+        if (txSpectrumModelUid == rxSpectrumModelUid)
+        {
+            NS_LOG_LOGIC("no spectrum conversion needed");
+            convertedTxPowerSpectrum = txParams->psd;
+        }
+        else
+        {
+            NS_LOG_LOGIC("converting txPowerSpectrum SpectrumModelUids "
+                         << txSpectrumModelUid << " --> " << rxSpectrumModelUid);
+            auto rxConverterIterator =
+                txInfoIterator->second.m_spectrumConverterMap.find(rxSpectrumModelUid);
+            if (rxConverterIterator == txInfoIterator->second.m_spectrumConverterMap.end())
+            {
+                // No converter means TX SpectrumModel is orthogonal to RX SpectrumModel
+                continue;
+            }
+            convertedTxPowerSpectrum = rxConverterIterator->second.Convert(txParams->psd);
+        }
+        convertedPsds.emplace(rxSpectrumModelUid, convertedTxPowerSpectrum);
+    }
+
+    for (auto rxInfoIterator = m_rxSpectrumModelInfoMap.begin();
+         rxInfoIterator != m_rxSpectrumModelInfoMap.end();
+         ++rxInfoIterator)
+    {
+        const auto rxSpectrumModelUid = rxInfoIterator->second.m_rxSpectrumModel->GetUid();
+
+        if ((txSpectrumModelUid != rxSpectrumModelUid) &&
+            !txInfoIterator->second.m_spectrumConverterMap.contains(rxSpectrumModelUid))
+        {
+            // No converter means TX SpectrumModel is orthogonal to RX SpectrumModel
+            continue;
+        }
+
         for (auto rxPhyIterator = rxInfoIterator->second.m_rxPhys.begin();
              rxPhyIterator != rxInfoIterator->second.m_rxPhys.end();
              ++rxPhyIterator)
@@ -244,6 +289,7 @@
                           "SpectrumModel change was not notified to MultiModelSpectrumChannel "
                           "(i.e., AddRx should be called again after model is changed)");
 
+            auto txAntennaGain{0.0};
             if ((*rxPhyIterator) != txParams->txPhy)
             {
                 auto rxNetDevice = (*rxPhyIterator)->GetDevice();
@@ -268,64 +314,19 @@
 
                 NS_LOG_LOGIC("copying signal parameters " << txParams);
                 auto rxParams = txParams->Copy();
-                rxParams->psd = Copy<SpectrumValue>(txParams->psd);
+                rxParams->psd = Copy<SpectrumValue>(convertedPsds.at(rxSpectrumModelUid));
                 Time delay{0};
 
                 auto receiverMobility = (*rxPhyIterator)->GetMobility();
 
                 if (txMobility && receiverMobility)
                 {
-                    auto txAntennaGain{0.0};
-                    auto rxAntennaGain{0.0};
-                    auto propagationGainDb{0.0};
-                    auto pathLossDb{0.0};
                     if (rxParams->txAntenna)
                     {
                         Angles txAngles(receiverMobility->GetPosition(), txMobility->GetPosition());
                         txAntennaGain = rxParams->txAntenna->GetGainDb(txAngles);
                         NS_LOG_LOGIC("txAntennaGain = " << txAntennaGain << " dB");
-                        pathLossDb -= txAntennaGain;
-                    }
-                    auto rxAntenna = DynamicCast<AntennaModel>((*rxPhyIterator)->GetAntenna());
-                    if (rxAntenna)
-                    {
-                        Angles rxAngles(txMobility->GetPosition(), receiverMobility->GetPosition());
-                        rxAntennaGain = rxAntenna->GetGainDb(rxAngles);
-                        NS_LOG_LOGIC("rxAntennaGain = " << rxAntennaGain << " dB");
-                        pathLossDb -= rxAntennaGain;
-                    }
-                    if (m_propagationLoss)
-                    {
-                        if (txMobility->GetPosition() == receiverMobility->GetPosition())
-                        {
-                            propagationGainDb = 0; // Assume no propagation loss when co-located
-                        }
-                        else
-                        {
-                            propagationGainDb =
-                                m_propagationLoss->CalcRxPower(0, txMobility, receiverMobility);
-                        }
-                        NS_LOG_LOGIC("propagationGainDb = " << propagationGainDb << " dB");
-                        pathLossDb -= propagationGainDb;
-                    }
-                    NS_LOG_LOGIC("total pathLoss = " << pathLossDb << " dB");
-                    // Gain trace
-                    m_gainTrace(txMobility,
-                                receiverMobility,
-                                txAntennaGain,
-                                rxAntennaGain,
-                                propagationGainDb,
-                                pathLossDb);
-                    // Pathloss trace
-                    m_pathLossTrace(txParams->txPhy, *rxPhyIterator, pathLossDb);
-                    if (pathLossDb > m_maxLossDb)
-                    {
-                        // beyond range
-                        continue;
                     }
-                    auto pathGainLinear = std::pow(10.0, (-pathLossDb) / 10.0);
-                    *(rxParams->psd) *= pathGainLinear;
-
                     if (m_propagationDelay)
                     {
                         delay = m_propagationDelay->GetDelay(txMobility, receiverMobility);
@@ -340,8 +341,11 @@
                                                    delay,
                                                    &MultiModelSpectrumChannel::StartRx,
                                                    this,
+                                                   txParams->psd,
+                                                   txAntennaGain,
                                                    rxParams,
-                                                   *rxPhyIterator);
+                                                   *rxPhyIterator,
+                                                   convertedPsds);
                 }
                 else
                 {
@@ -350,8 +354,11 @@
                     Simulator::Schedule(delay,
                                         &MultiModelSpectrumChannel::StartRx,
                                         this,
+                                        txParams->psd,
+                                        txAntennaGain,
                                         rxParams,
-                                        *rxPhyIterator);
+                                        *rxPhyIterator,
+                                        convertedPsds);
                 }
             }
         }
@@ -359,66 +366,122 @@
 }
 
 void
-MultiModelSpectrumChannel::StartRx(Ptr<SpectrumSignalParameters> params, Ptr<SpectrumPhy> receiver)
+MultiModelSpectrumChannel::StartRx(
+    Ptr<SpectrumValue> txPsd,
+    double txAntennaGain,
+    Ptr<SpectrumSignalParameters> params,
+    Ptr<SpectrumPhy> receiver,
+    const std::map<SpectrumModelUid_t, Ptr<SpectrumValue>>& availableConvertedPsds)
 {
     NS_LOG_FUNCTION(this);
-    const auto txSpectrumModelUid = params->psd->GetSpectrumModelUid();
-    const auto rxSpectrumModelUid = receiver->GetRxSpectrumModel()->GetUid();
 
-    auto txInfoIteratorerator =
-        FindAndEventuallyAddTxSpectrumModel(params->psd->GetSpectrumModel());
-    NS_ASSERT(txInfoIteratorerator != m_txSpectrumModelInfoMap.end());
-
-    NS_LOG_LOGIC("converter map for TX SpectrumModel with Uid " << txInfoIteratorerator->first);
-    NS_LOG_LOGIC(
-        "converter map size: " << txInfoIteratorerator->second.m_spectrumConverterMap.size());
-    NS_LOG_LOGIC("converter map first element: "
-                 << txInfoIteratorerator->second.m_spectrumConverterMap.begin()->first);
+    const auto rxSpectrumModelUid = params->psd->GetSpectrumModelUid();
+    const auto phySpectrumModelUid = receiver->GetRxSpectrumModel()->GetUid();
+    NS_LOG_LOGIC("rxSpectrumModelUid " << rxSpectrumModelUid << " phySpectrumModelUid "
+                                       << phySpectrumModelUid);
 
-    Ptr<SpectrumValue> convertedPsd;
-    if (txSpectrumModelUid == rxSpectrumModelUid)
+    if (rxSpectrumModelUid != phySpectrumModelUid)
     {
-        NS_LOG_LOGIC("no spectrum conversion needed");
-        convertedPsd = params->psd;
+        NS_LOG_LOGIC("SpectrumModelUid changed since TX started");
+
+        const auto itConvertedPsd = availableConvertedPsds.find(phySpectrumModelUid);
+        if (itConvertedPsd != availableConvertedPsds.cend())
+        {
+            NS_LOG_LOGIC("converted PSD already exists for " << phySpectrumModelUid);
+            params->psd = itConvertedPsd->second;
+        }
+        else
+        {
+            const auto txInfoIterator =
+                FindAndEventuallyAddTxSpectrumModel(txPsd->GetSpectrumModel());
+            NS_ASSERT(txInfoIterator != m_txSpectrumModelInfoMap.cend());
+
+            const auto txSpectrumModelUid = txPsd->GetSpectrumModelUid();
+            NS_LOG_LOGIC("converting txPowerSpectrum SpectrumModelUids "
+                         << txSpectrumModelUid << " --> " << phySpectrumModelUid);
+            const auto rxConverterIterator =
+                txInfoIterator->second.m_spectrumConverterMap.find(phySpectrumModelUid);
+            if (rxConverterIterator == txInfoIterator->second.m_spectrumConverterMap.cend())
+            {
+                // No converter means TX SpectrumModel is orthogonal to current PHY SpectrumModel
+                params->psd = txPsd;
+            }
+            else
+            {
+                params->psd = rxConverterIterator->second.Convert(txPsd);
+            }
+        }
     }
-    else
+
+    auto txMobility = params->txPhy->GetMobility();
+    auto rxMobility = receiver->GetMobility();
+    if (txMobility && rxMobility)
     {
-        NS_LOG_LOGIC("converting txPowerSpectrum SpectrumModelUids "
-                     << txSpectrumModelUid << " --> " << rxSpectrumModelUid);
-        auto rxConverterIterator =
-            txInfoIteratorerator->second.m_spectrumConverterMap.find(rxSpectrumModelUid);
-        if (rxConverterIterator == txInfoIteratorerator->second.m_spectrumConverterMap.end())
+        auto pathLossDb{-txAntennaGain};
+        auto rxAntennaGain{0.0};
+        auto propagationGainDb{0.0};
+
+        if (auto rxAntenna = DynamicCast<AntennaModel>(receiver->GetAntenna()))
         {
-            // No converter means TX SpectrumModel is orthogonal to RX SpectrumModel
+            Angles rxAngles(txMobility->GetPosition(), rxMobility->GetPosition());
+            rxAntennaGain = rxAntenna->GetGainDb(rxAngles);
+            NS_LOG_LOGIC("rxAntennaGain = " << rxAntennaGain << " dB");
+            pathLossDb -= rxAntennaGain;
+        }
+
+        if (m_propagationLoss && (txMobility->GetPosition() != rxMobility->GetPosition()))
+        {
+            propagationGainDb = m_propagationLoss->CalcRxPower(0, txMobility, rxMobility);
+            NS_LOG_LOGIC("propagationGainDb = " << propagationGainDb << " dB");
+            pathLossDb -= propagationGainDb;
+        }
+
+        NS_LOG_LOGIC("total pathLoss = " << pathLossDb << " dB");
+
+        // Gain trace
+        m_gainTrace(txMobility,
+                    rxMobility,
+                    txAntennaGain,
+                    rxAntennaGain,
+                    propagationGainDb,
+                    pathLossDb);
+
+        // Pathloss trace
+        m_pathLossTrace(params->txPhy, receiver, pathLossDb);
+
+        if (pathLossDb > m_maxLossDb)
+        {
+            // beyond range
             return;
         }
-        convertedPsd = rxConverterIterator->second.Convert(params->psd);
-        NS_LOG_LOGIC("convertedPsd " << convertedPsd->GetValuesN());
-    }
-    params->psd = convertedPsd;
-    if (m_spectrumPropagationLoss)
-    {
-        params->psd =
-            m_spectrumPropagationLoss->CalcRxPowerSpectralDensity(params,
-                                                                  params->txPhy->GetMobility(),
-                                                                  receiver->GetMobility());
-    }
-    else if (m_phasedArraySpectrumPropagationLoss)
-    {
-        auto txPhasedArrayModel = DynamicCast<PhasedArrayModel>(params->txPhy->GetAntenna());
-        auto rxPhasedArrayModel = DynamicCast<PhasedArrayModel>(receiver->GetAntenna());
 
-        NS_ASSERT_MSG(txPhasedArrayModel && rxPhasedArrayModel,
-                      "PhasedArrayModel instances should be installed at both TX and RX "
-                      "SpectrumPhy in order to use PhasedArraySpectrumPropagationLoss.");
-
-        params = m_phasedArraySpectrumPropagationLoss->CalcRxPowerSpectralDensity(
-            params,
-            params->txPhy->GetMobility(),
-            receiver->GetMobility(),
-            txPhasedArrayModel,
-            rxPhasedArrayModel);
+        const auto pathLossLinear = std::pow(10.0, (-pathLossDb) / 10.0);
+        *(params->psd) *= pathLossLinear;
+
+        if (m_spectrumPropagationLoss)
+        {
+            params->psd = m_spectrumPropagationLoss->CalcRxPowerSpectralDensity(params,
+                                                                                txMobility,
+                                                                                rxMobility);
+        }
+        else if (m_phasedArraySpectrumPropagationLoss)
+        {
+            auto txPhasedArrayModel = DynamicCast<PhasedArrayModel>(params->txPhy->GetAntenna());
+            auto rxPhasedArrayModel = DynamicCast<PhasedArrayModel>(receiver->GetAntenna());
+
+            NS_ASSERT_MSG(txPhasedArrayModel && rxPhasedArrayModel,
+                          "PhasedArrayModel instances should be installed at both TX and RX "
+                          "SpectrumPhy in order to use PhasedArraySpectrumPropagationLoss.");
+
+            params = m_phasedArraySpectrumPropagationLoss->CalcRxPowerSpectralDensity(
+                params,
+                txMobility,
+                rxMobility,
+                txPhasedArrayModel,
+                rxPhasedArrayModel);
+        }
     }
+
     receiver->StartRx(params);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/spectrum/model/multi-model-spectrum-channel.h ns-3.44/src/spectrum/model/multi-model-spectrum-channel.h
--- ns-3.43/src/spectrum/model/multi-model-spectrum-channel.h	2024-10-09 16:41:10.088656700 -0700
+++ ns-3.44/src/spectrum/model/multi-model-spectrum-channel.h	2025-03-09 16:55:49.695372300 -0700
@@ -14,7 +14,7 @@
 #include "spectrum-propagation-loss-model.h"
 #include "spectrum-value.h"
 
-#include <ns3/propagation-delay-model.h>
+#include "ns3/propagation-delay-model.h"
 
 #include <map>
 #include <set>
@@ -23,13 +23,13 @@
 {
 
 /**
- * \ingroup spectrum
+ * @ingroup spectrum
  * Container: SpectrumModelUid_t, SpectrumConverter
  */
 typedef std::map<SpectrumModelUid_t, SpectrumConverter> SpectrumConverterMap_t;
 
 /**
- * \ingroup spectrum
+ * @ingroup spectrum
  * The Tx spectrum model information. This class is used to convert
  * one spectrum model into another one.
  */
@@ -38,7 +38,7 @@
   public:
     /**
      * Constructor.
-     * \param txSpectrumModel the Tx Spectrum model.
+     * @param txSpectrumModel the Tx Spectrum model.
      */
     TxSpectrumModelInfo(Ptr<const SpectrumModel> txSpectrumModel);
 
@@ -47,13 +47,13 @@
 };
 
 /**
- * \ingroup spectrum
+ * @ingroup spectrum
  * Container: SpectrumModelUid_t, TxSpectrumModelInfo
  */
 typedef std::map<SpectrumModelUid_t, TxSpectrumModelInfo> TxSpectrumModelInfoMap_t;
 
 /**
- * \ingroup spectrum
+ * @ingroup spectrum
  * The Rx spectrum model information. This class is used to convert
  * one spectrum model into another one.
  */
@@ -62,7 +62,7 @@
   public:
     /**
      * Constructor.
-     * \param rxSpectrumModel the Rx Spectrum model.
+     * @param rxSpectrumModel the Rx Spectrum model.
      */
     RxSpectrumModelInfo(Ptr<const SpectrumModel> rxSpectrumModel);
 
@@ -71,19 +71,19 @@
 };
 
 /**
- * \ingroup spectrum
+ * @ingroup spectrum
  * Container: SpectrumModelUid_t, RxSpectrumModelInfo
  */
 typedef std::map<SpectrumModelUid_t, RxSpectrumModelInfo> RxSpectrumModelInfoMap_t;
 
 /**
- * \ingroup spectrum
+ * @ingroup spectrum
  *
  * This SpectrumChannel implementation can handle the presence of
  * SpectrumPhy instances which can use
  * different spectrum models, i.e.,  different SpectrumModel.
  *
- * \note It is allowed for a receiving SpectrumPhy to switch to a
+ * @note It is allowed for a receiving SpectrumPhy to switch to a
  * different SpectrumModel during the simulation. The requirement
  * for this to work is that, after the SpectrumPhy switched its
  * SpectrumModel,  MultiModelSpectrumChannel::AddRx () is
@@ -95,8 +95,8 @@
     MultiModelSpectrumChannel();
 
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
@@ -119,9 +119,9 @@
      * an iterator pointing to it. If not, it creates a new entry in
      * m_txSpectrumModelInfoMap, and returns an iterator to it.
      *
-     * \param txSpectrumModel The TX SpectrumModel  being considered
+     * @param txSpectrumModel The TX SpectrumModel  being considered
      *
-     * \return An iterator pointing to the corresponding entry in m_txSpectrumModelInfoMap
+     * @return An iterator pointing to the corresponding entry in m_txSpectrumModelInfoMap
      */
     TxSpectrumModelInfoMap_t::const_iterator FindAndEventuallyAddTxSpectrumModel(
         Ptr<const SpectrumModel> txSpectrumModel);
@@ -129,10 +129,18 @@
     /**
      * Used internally to reschedule transmission after the propagation delay.
      *
-     * \param params The signal parameters.
-     * \param receiver A pointer to the receiver SpectrumPhy.
+     * @param txPsd The transmitted PSD.
+     * @param txAntennaGain The antenna gain at the transmitter.
+     * @param params The signal parameters.
+     * @param receiver A pointer to the receiver SpectrumPhy.
+     * @param availableConvertedPsds available converted PSDs from the TX PSD.
      */
-    virtual void StartRx(Ptr<SpectrumSignalParameters> params, Ptr<SpectrumPhy> receiver);
+    virtual void StartRx(
+        Ptr<SpectrumValue> txPsd,
+        double txAntennaGain,
+        Ptr<SpectrumSignalParameters> params,
+        Ptr<SpectrumPhy> receiver,
+        const std::map<SpectrumModelUid_t, Ptr<SpectrumValue>>& availableConvertedPsds);
 
     /**
      * Data structure holding, for each TX SpectrumModel,  all the
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/spectrum/model/non-communicating-net-device.h ns-3.44/src/spectrum/model/non-communicating-net-device.h
--- ns-3.43/src/spectrum/model/non-communicating-net-device.h	2024-10-09 16:41:10.088656700 -0700
+++ ns-3.44/src/spectrum/model/non-communicating-net-device.h	2025-03-09 16:55:49.695372300 -0700
@@ -9,13 +9,13 @@
 #ifndef NON_COMMUNICATING_NET_DEVICE_H
 #define NON_COMMUNICATING_NET_DEVICE_H
 
-#include <ns3/address.h>
-#include <ns3/callback.h>
-#include <ns3/net-device.h>
-#include <ns3/node.h>
-#include <ns3/packet.h>
-#include <ns3/ptr.h>
-#include <ns3/traced-callback.h>
+#include "ns3/address.h"
+#include "ns3/callback.h"
+#include "ns3/net-device.h"
+#include "ns3/node.h"
+#include "ns3/packet.h"
+#include "ns3/ptr.h"
+#include "ns3/traced-callback.h"
 
 #include <cstring>
 
@@ -27,7 +27,7 @@
 class SpectrumErrorModel;
 
 /**
- * \ingroup spectrum
+ * @ingroup spectrum
  *
  * This class implements a device which does not communicate, in the
  * sense that it does not interact with the above protocol stack. The
@@ -41,8 +41,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/spectrum/model/phased-array-spectrum-propagation-loss-model.cc ns-3.44/src/spectrum/model/phased-array-spectrum-propagation-loss-model.cc
--- ns-3.43/src/spectrum/model/phased-array-spectrum-propagation-loss-model.cc	2024-10-09 16:41:10.088656700 -0700
+++ ns-3.44/src/spectrum/model/phased-array-spectrum-propagation-loss-model.cc	2025-03-09 16:55:49.695372300 -0700
@@ -9,8 +9,8 @@
 
 #include "spectrum-signal-parameters.h"
 
-#include <ns3/log.h>
-#include <ns3/phased-array-model.h>
+#include "ns3/log.h"
+#include "ns3/phased-array-model.h"
 
 namespace ns3
 {
